; SAVE ADDR. $49000 $58f64
; by Filippetto/Savage
; Absolute Address fixed by VrS! 2009

;jmp	$49000
;org	$49000
;load	$49000

joy0dat = $dff00a
joy1dat = $dff00c
bltApth = $dff050
bltAptl = $dff052
bltBpth = $dff04c
bltBptl = $dff04e
bltCpth = $dff048
bltCptl = $dff04a
bltDpth = $dff054
bltDptl = $dff056
bltAmod = $dff064
bltBmod = $dff062
bltCmod = $dff060
bltDmod = $dff066
bltcon0 = $dff040
bltcon1 = $dff042
bltsize = $dff058
bltAmk1 = $dff044
bltAmk2 = $dff046
	
	opt	o-

	section	code,code_c

startmain:
	movem.l	d0-d7/a0-a6,-(sp)

	move.l	$80.w,intrpt0
	move.l 	#gogo,$80.w		; start in supervisor mode
	trap 	#$00

gogo:
	move.w 	#$2700,sr

	move.w 	#$1ffe,d0
	lea 	screen2,a0
	lea 	screen1,a1
clearloop:
	clr.b 	(a0)+
	clr.l 	(a1)+
	dbf 	d0,clearloop

	move.w 	#$87f0,$dff096
	move.l 	#copperl,$dff080
	clr.w 	$dff088
	clr.w 	$dff036
	MOVE.L	#charset,COUNT
	MOVE.L	#TESTO,CHCON
	CLR.B	PAUSA
	bsr	initsprites
	bsr	init_music

	move.w 	#359,d0
	lea 	sinusmat3(pc),a0
molt:	clr.l d1
	move.w 	(a0),d1
	muls 	#$2c,d1
	move.w 	d1,(a0)+
	dbf 	d0,molt

	bsr 	make_colors
	bra 	wb
	
end:
	move.w 	#$8020,$dff096
	move.w 	#$8010,$dff096
	move.w 	#$0000,sr
	move.l 	intrpt0(pc),$80.w
	bsr	end_music
	lea 	gn(pc),a1
	move.l	4.w,a6
	jsr	-408(a6)
	move.l	d0,a1
	move.l	$26(a1),$dff080		; restore old copper
	clr.w	$dff088
	jsr	-414(a6)
	moveq 	#$00,d0
	movem.l	(sp)+,d0-d7/a0-a6
	rts	
;--------------------------------------------------------
scrolltext:
	BTST	#1,PAUSA
	BNE	RITARDO

CONT:
	MOVE.B	passo,D1
	ADD.B	D1,SH
	CMP.B	#16,SH
	Blt	XYZ
	CLR.B	SH	
	Bsr	POSTEXT

XYZ:
	MOVE.L	#screen2+$2e0,SOURCEA	;SHIFT 
	BSR	BLIT2
	RTS

RITARDO:
	move.l 	brit,d5
	SUB.L	#2,D5
	BCC	LP
	CLR.B	PAUSA
	MOVE.L	#350,D5

LP:
	move.l 	d5,brit
	RTS

POSTEXT:
	CLR.L	D0	
	MOVE.L	CHCON,A0
	MOVE.B	(A0),D0

PLOT:
	SUB.B	#$20,D0			;CALCOLO DI COLONNA
	LSL.L	#1,D0
	ADD.L	D0,COUNT
	bsr	plot2	

RITRO:
	ADD.L	#1,CHCON		;INCREMENTA TESTO
	MOVE.L	CHCON,A0

JM0:
	CMP.B	#$FF,(A0)		;$FF FINE TESTO
	BNE	JM1
	MOVE.L	#TESTO,CHCON
	RTS	

JM1:
	CMP.B	#10,(A0)
	BLE	CONTEFF
	RTS

CONTEFF:
	MOVE.B	(A0),D0
	ASL	#2,D0
	LEA	TABLE,A2
	MOVE.L	$0(A2,D0),A3
	JSR	(A3)
	ADD.L	#1,CHCON
	RTS

EFF0:
	BSET	#1,PAUSA
	RTS

EFF1:
	RTS

EFF2:
	MOVE.B	#1,PASSO	
	MOVE.W	#$19F0,SHIFT
	RTS

EFF3:
	MOVE.B	#2,PASSO	
	MOVE.W	#$29F0,SHIFT
	RTS

EFF4:
	MOVE.B	#4,PASSO	
	MOVE.W	#$49F0,SHIFT
	RTS

EFF5:
	MOVE.B	#8,PASSO	
	MOVE.W	#$89F0,SHIFT
	RTS

EFF6:
	MOVE.B	#16,PASSO	
	MOVE.W	#$F9F0,SHIFT
	RTS

EFF7:
	MOVE.B	#0,sspeed
	RTS

EFF8:
	MOVE.B	#8,sspeed
	RTS

EFF9:
	MOVE.B	#10,sspeed
	RTS

PLOT2:
	MOVE.L	#screen2+$2c,DEST
	BSR	TEXT
	MOVE.L	#charset,COUNT
	RTS	

TEXT:
	MOVE.L	count,$DFF050	;SOURCE
	MOVE.L	DEST,$DFF054	;DESTINATION
 	MOVE.W	#158,$DFF064	;MODULO	SOURCE
	MOVE.W	#44,$DFF066	;MODULO DESTINATION
	MOVE.W	#$09F0,$DFF040
	MOVE.W	#$0000,$DFF042
	MOVE.L	#$FFFFFFFF,$DFF044
	MOVE.W	#%0000010000000001,$DFF058
	RTS

BLIT2:
	MOVE.L	SOURCEA,$DFF050	;SOURCE A
	MOVE.L	SOURCEA,$DFF054	;DESTINATION
	MOVE.W	#0,$DFF064	;MODULO	SOURCE A
	MOVE.W	#0,$DFF066	;MODULO DESTINATION
	MOVE.W	shift,$DFF040
	MOVE.W	#$0002,$DFF042
	MOVE.L	#$FFFFFFFF,$DFF044
	MOVE.W	#%0000010000010111,$DFF058	
	RTS

waitblit:
	btst 	#$0e,$dff002
	bne.s 	waitblit
	rts
;--------
clearscreen:
	bsr 	waitblit
	move.l 	#$09000000,bltcon0
	move.w 	#00,bltdmod
	move.l 	#screen1+5720-3300+88,bltdpth
	move.w 	#%0010010100011000,bltsize
	bsr 	waitblit
	rts
;-------
sinusrender:
	clr.l 	d0
	move.l 	#screen1+5720,d1	
	move.l 	#screen2,d2	;source buffer
	clr.l 	d3
	move.w 	#$f000,d3
	move.b 	sspeed,d0
	add.l 	d0,sinusloc
	move.l 	sinusloc,a2
	cmp.b 	#$aa,(A2)
	bne 	sr1
	move.l 	#sinusmat3,sinusloc
	move.l 	#sinusmat3,a2

sr1:
	move.w 	#86,d0
	move.w 	#$0dfc,bltcon0
	clr.w 	bltcon1
	move.w 	#44,bltamod
	move.w 	#42,bltbmod
	move.w 	#42,bltdmod
	move.w 	#$4,bltdpth
	move.w 	#$4,bltbpth
	move.w 	#$3,bltapth
	
sinuscrollstart:
	add.w 	(a2),d1
	move.w 	d3,bltamk1
	move.w 	d2,bltapth+2
	move.w 	d1,bltbpth+2
	move.w 	d1,bltdpth+2
	move.w 	#%0000001101000001,bltsize
	sub.w 	(a2)+,d1
	ror.w 	#$04,d3
	bcc.s 	ss2
	addq.w 	#$02,d1
	addq.w 	#$02,d2		

ss2:
	cmp.b 	#$aa,(a2)
	bne.s 	ss4
	lea 	sinusmat3,a2

ss4:
	dbf 	d0,sinuscrollstart
	rts
;----------------------------------------------------------- main
wb:	
	bsr 	waitblit
	move.l 	#$ffffffff,bltamk1
	move.w 	#$09f0,bltcon0
	move.w 	#$0000,bltcon1
	move.w 	#12,bltdmod
	clr.w 	bltamod
	move.l 	#screen1+$b600,bltapth
	move.l 	#screen1+6+176+528,bltdpth
	move.w 	#%0000100110010000,bltsize
	bsr 	waitblit

waitbeam:
	cmp.b	#$fd,$dff006
	bne.s 	waitbeam
	move.w 	#$85f0,$dff096
	move.w 	#$8020,$dff096
	bsr	scroll_colors
	bsr	play
	bsr	movestars
	bsr 	clearscreen
	bsr 	sinusrender
	bsr 	scrolltext
	move.w 	$dff006,d7
	btst 	#$02,$dff016
	beq 	end
	clr.w 	$dff036
	bra 	waitbeam

MENAGE_SYNC:
	MOVE.W	#$030,D7
	MOVE.W	$02(A0),D0

SYNC0:
	MOVE.W	$06(A0),$02(A0)
	ADD.L	#$04,A0
	SUB.W	#$01,D7
	BNE	SYNC0
	MOVE.W	D0,-(A0)
	RTS

Make_colors:
	LEA	LACE,A0
	LEA	COLORS1,A1
	BSR	MAKE_IT
	LEA	LACE2,A0
	LEA	COLORS1,A1
	BSR	MAKE_IT
	RTS

Scroll_Colors:
	LEA	LACE,A0
	BSR	MENAGE_SYNC
	LEA	LACE2,A0
	BSR	MENAGE_SYNC
	rts

MAKE_IT:
	MOVE.W	#$01,D6

MAIN0:
	MOVE.W	#$30,D7
	MOVE.L	A1,A2

COP0:
	AND.W	#$FFFF,(A0)+
	MOVE.W	(A2)+,(A0)+
	SUB.W	#$01,D7
	BNE	COP0
	SUB.W	#$01,D6
	BNE	MAIN0
	RTS
;-----------------------------------------------
Initsprites:
	move.l	#sprite0,d0
	move.w	d0,sp2
	swap	d0
	move.w	d0,sp1
	rts

Movestars:
	lea	sprite0+1,a0
	moveq	#sprite0_end-sprite0-4/8-1,d1
	moveq	#1,d2

stars_loop:
	cmp.b	#$d9,(a0)
	bne.s	stars_weiter1
	move.b	#$3f,(a0)	
	bra.s	stars_no_add	

stars_weiter1:
	add.b	d2,(a0)

stars_no_add:
	addq.l	#1,d2
	cmp.b	#6,d2
	bne.s	stars_weiter2
	moveq	#1,d2

stars_weiter2:
	addq.l	#8,a0
	dbra	d1,stars_loop

stars_end:
	rts
;------------------------------------------------------
END_MUSIC:
	clr.w onoff
	clr.l $dff0a6
	clr.l $dff0b6
	clr.l $dff0c6
	clr.l $dff0d6
	move.w #$000f,$dff096
	bclr #1,$bfe001
	rts

INIT_MUSIC:
	move.w #1,onoff
	bset #1,$bfe001
	lea MODULE,a0
	lea 100(a0),a1
	move.l a1,SEQpoint
	move.l a0,a1
	add.l 8(a0),a1
	move.l a1,PATpoint
	move.l a0,a1
	add.l 16(a0),a1
	move.l a1,FRQpoint
	move.l a0,a1
	add.l 24(a0),a1
	move.l a1,VOLpoint
	move.l 4(a0),d0
	divu #13,d0

	lea 40(a0),a1
	lea SOUNDINFO+4(pc),a2
	moveq #10-1,d1
initloop:
	move.w (a1)+,(a2)+
	move.l (a1)+,(a2)+
	addq.w #4,a2
	dbf d1,initloop
	moveq #0,d2
	move.l a0,d1
	add.l 32(a0),d1
	sub.l #WAVEFORMS,d1
	lea SOUNDINFO(pc),a0
	move.l d1,(a0)+
	moveq #9-1,d3
initloop1:
	move.w (a0),d2
	add.l d2,d1
	add.l d2,d1
	addq.w #6,a0
	move.l d1,(a0)+
	dbf d3,initloop1

	move.l SEQpoint(pc),a0
	moveq #0,d2
	move.b 12(a0),d2		;Get replay speed
	bne.s speedok
	move.b #3,d2			;Set default speed
speedok:
	move.w d2,respcnt		;Init repspeed counter
	move.w d2,repspd
INIT2:
	clr.w audtemp
	move.w #$000f,$dff096		;Disable audio DMA
	move.w #$0780,$dff09a		;Disable audio IRQ
	moveq #0,d7
	mulu #13,d0
	moveq #4-1,d6			;Number of soundchannels-1
	lea V1data(pc),a0		;Point to 1st voice data area
	lea silent(pc),a1
	lea o4a0c8(pc),a2
initloop2:
	move.l a1,10(a0)
	move.l a1,18(a0)
	clr.l 14(a0)
	clr.b 45(a0)
	clr.b 47(a0)
	clr.w 8(a0)
	clr.l 48(a0)
	move.b #$01,23(a0)
	move.b #$01,24(a0)
	clr.b 25(a0)
	clr.l 26(a0)
	clr.w 30(a0)
	moveq #$00,d3
	move.w (a2)+,d1
	move.w (a2)+,d3
	divu #$0003,d3
	move.b d3,32(a0)
	mulu #$0003,d3
	andi.l #$00ff,d3
	andi.l #$00ff,d1
	addi.l #$dff0a0,d1
	move.l d1,a6
	move.l #$0000,(a6)
	move.w #$0100,4(a6)
	move.w #$0000,6(a6)
	move.w #$0000,8(a6)
	move.l d1,60(a0)
	clr.w 64(a0)
	move.l SEQpoint(pc),(a0)
	move.l SEQpoint(pc),52(a0)
	add.l d0,52(a0)
	add.l d3,52(a0)
	add.l d7,(a0)
	add.l d3,(a0)
	move.w #$000d,6(a0)
	move.l (a0),a3
	move.b (a3),d1
	andi.l #$00ff,d1
	lsl.w #6,d1
	move.l PATpoint(pc),a4
	adda.w d1,a4
	move.l a4,34(a0)
	clr.l 38(a0)
	move.b #$01,33(a0)
	move.b #$02,42(a0)
	move.b 1(a3),44(a0)
	move.b 2(a3),22(a0)
	clr.b 43(a0)
	clr.b 45(a0)
	clr.w 56(a0)
	adda.w #$004a,a0	;Point to next voice's data area
	dbf d6,initloop2
	rts


PLAY:
	lea pervol(pc),a6
	tst.w onoff
	bne.s music_on
	rts
music_on:
	subq.w #1,respcnt		;Decrease replayspeed counter
	bne.s nonewnote
	move.w repspd(pc),respcnt	;Restore replayspeed counter
	lea V1data(pc),a0		;Point to voice1 data area
	bsr.L new_note
	lea V2data(pc),a0		;Point to voice2 data area
	bsr.L new_note
	lea V3data(pc),a0		;Point to voice3 data area
	bsr.L new_note
	lea V4data(pc),a0		;Point to voice4 data area
	bsr.L new_note
nonewnote:
	clr.w audtemp
	lea V1data(pc),a0
	bsr.L effects
	move.w d0,(a6)+
	move.w d1,(a6)+
	lea V2data(pc),a0
	bsr.L effects
	move.w d0,(a6)+
	move.w d1,(a6)+
	lea V3data(pc),a0
	bsr.L effects
	move.w d0,(a6)+
	move.w d1,(a6)+
	lea V4data(pc),a0
	bsr.L effects
	move.w d0,(a6)+
	move.w d1,(a6)+
	lea pervol(pc),a6
	move.w audtemp(pc),d0
	ori.w #$8000,d0			;Set/clr bit = 1
	move.w d0,-(a7)
	moveq #0,d1
	move.l start1(pc),d2		;Get samplepointers
	move.w offset1(pc),d1		;Get offset
	add.l d1,d2			;Add offset
	move.l start2(pc),d3
	move.w offset2(pc),d1
	add.l d1,d3
	move.l start3(pc),d4
	move.w offset3(pc),d1
	add.l d1,d4
	move.l start4(pc),d5
	move.w offset4(pc),d1
	add.l d1,d5
	move.w ssize1(pc),d0		;Get sound lengths
	move.w ssize2(pc),d1
	move.w ssize3(pc),d6
	move.w ssize4(pc),d7
	move.w (a7)+,$dff096		;Enable audio DMA
chan1:
	lea V1data(pc),a0
	tst.w 72(a0)
	beq.l chan2
	subq.w #1,72(a0)
	cmpi.w #1,72(a0)
	bne.s chan2
	clr.w 72(a0)
	move.l d2,$dff0a0		;Set soundstart
	move.w d0,$dff0a4		;Set soundlength
chan2:
	lea V2data(pc),a0
	tst.w 72(a0)
	beq.s chan3
	subq.w #1,72(a0)
	cmpi.w #1,72(a0)
	bne.s chan3
	clr.w 72(a0)
	move.l d3,$dff0b0
	move.w d1,$dff0b4
chan3:
	lea V3data(pc),a0
	tst.w 72(a0)
	beq.s chan4
	subq.w #1,72(a0)
	cmpi.w #1,72(a0)
	bne.s chan4
	clr.w 72(a0)
	move.l d4,$dff0c0
	move.w d6,$dff0c4
chan4:
	lea V4data(pc),a0
	tst.w 72(a0)
	beq.s setpervol
	subq.w #1,72(a0)
	cmpi.w #1,72(a0)
	bne.s setpervol
	clr.w 72(a0)
	move.l d5,$dff0d0
	move.w d7,$dff0d4
setpervol:
	lea $dff0a6,a5
	move.w (a6)+,(a5)	;Set period
	move.w (a6)+,2(a5)	;Set volume
	move.w (a6)+,16(a5)
	move.w (a6)+,18(a5)
	move.w (a6)+,32(a5)
	move.w (a6)+,34(a5)
	move.w (a6)+,48(a5)
	move.w (a6)+,50(a5)
	rts

NEW_NOTE:
	moveq #0,d5
	move.l 34(a0),a1
	adda.w 40(a0),a1
	cmp.w #64,40(a0)
	bne.L samepat
	move.l (a0),a2
	adda.w 6(a0),a2		;Point to next sequence row
	cmpa.l 52(a0),a2	;Is it the end?
	bne.s notend
	move.w d5,6(a0)		;yes!
	move.l (a0),a2		;Point to first sequence
notend:
	moveq #0,d1
	addq.b #1,spdtemp
	cmpi.b #4,spdtemp
	bne.s nonewspd
	move.b d5,spdtemp
	move.b -1(a1),d1	;Get new replay speed
	beq.s nonewspd
	move.w d1,respcnt	;store in counter
	move.w d1,repspd
nonewspd:
	move.b (a2),d1		;Pattern to play
	move.b 1(a2),44(a0)	;Transpose value
	move.b 2(a2),22(a0)	;Soundtranspose value

	move.w d5,40(a0)
	lsl.w #6,d1
	add.l PATpoint(pc),d1	;Get pattern pointer
	move.l d1,34(a0)
	addi.w #$000d,6(a0)
	move.l d1,a1
samepat:
	move.b 1(a1),d1		;Get info byte
	move.b (a1)+,d0		;Get note
	bne.s ww1
	andi.w #%11000000,d1
	beq.s noport
	bra.s ww11
ww1:
	move.w d5,56(a0)
ww11:
	move.b d5,47(a0)
	move.b (a1),31(a0)

		;31(a0) = PORTAMENTO/INSTR. info
			;Bit 7 = portamento on
			;Bit 6 = portamento off
			;Bit 5-0 = instrument number
		;47(a0) = portamento value
			;Bit 7-5 = always zero
			;Bit 4 = up/down
			;Bit 3-0 = value
t_porton:
	btst #7,d1
	beq.s noport
	move.b 2(a1),47(a0)	
noport:
	andi.w #$007f,d0
	beq.L nextnote
	move.b d0,8(a0)
	move.b (a1),9(a0)
	move.b 32(a0),d2
	moveq #0,d3
	bset d2,d3
	or.w d3,audtemp
	move.w d3,$dff096
	move.b (a1),d1
	andi.w #$003f,d1	;Max 64 instruments
	add.b 22(a0),d1
	move.l VOLpoint(pc),a2
	lsl.w #6,d1
	adda.w d1,a2
	move.w d5,16(a0)
	move.b (a2),23(a0)
	move.b (a2)+,24(a0)
	move.b (a2)+,d1
	andi.w #$00ff,d1
	move.b (a2)+,27(a0)
	move.b #$40,46(a0)
	move.b (a2)+,d0
	move.b d0,28(a0)
	move.b d0,29(a0)
	move.b (a2)+,30(a0)
	move.l a2,10(a0)
	move.l FRQpoint(pc),a2
	lsl.w #6,d1
	adda.w d1,a2
	move.l a2,18(a0)
	move.w d5,50(a0)
	move.b d5,26(a0)
	move.b d5,25(a0)
nextnote:
	addq.w #2,40(a0)
	rts

EFFECTS:
	moveq #0,d7
testsustain:
	tst.b 26(a0)		;Is sustain counter = 0
	beq.s sustzero
	subq.b #1,26(a0)	;if no, decrease counter
	bra.L VOLUfx
sustzero:		;Next part of effect sequence
	move.l 18(a0),a1	;can be executed now.
	adda.w 50(a0),a1
testeffects:
	cmpi.b #$e1,(a1)	;E1 = end of FREQseq sequence
	beq.L VOLUfx
	cmpi.b #$e0,(a1)	;E0 = loop to other part of sequence
	bne.s testnewsound
	move.b 1(a1),d0		;loop to start of sequence + 1(a1)
	andi.w #$003f,d0
	move.w d0,50(a0)
	move.l 18(a0),a1
	adda.w d0,a1
testnewsound:
	cmpi.b #$e2,(a1)	;E2 = set waveform
	bne.s o49c64
	moveq #0,d0
	moveq #0,d1
	move.b 32(a0),d1
	bset d1,d0
	or.w d0,audtemp
	move.w d0,$dff096
	move.b 1(a1),d0
	andi.w #$00ff,d0
	lea SOUNDINFO(pc),a4
	add.w d0,d0
	move.w d0,d1
	add.w d1,d1
	add.w d1,d1
	add.w d1,d0
	adda.w d0,a4
	move.l 60(a0),a3
	move.l (a4),d1
	add.l #WAVEFORMS,d1
	move.l d1,(a3)
	move.l d1,68(a0)
	move.w 4(a4),4(a3)
	move.l 6(a4),64(a0)
	swap d1
	move.w #$0003,72(a0)
	tst.w d1
	bne.s o49c52
	move.w #$0002,72(a0)
o49c52:
	clr.w 16(a0)
	move.b #$01,23(a0)
	addq.w #2,50(a0)
	bra.L o49d02
o49c64:
	cmpi.b #$e4,(a1)
	bne.s testpatjmp
	move.b 1(a1),d0
	andi.w #$00ff,d0
	lea SOUNDINFO(pc),a4
	add.w d0,d0
	move.w d0,d1
	add.w d1,d1
	add.w d1,d1
	add.w d1,d0
	adda.w d0,a4
	move.l 60(a0),a3
	move.l (a4),d1
	add.l #WAVEFORMS,d1
	move.l d1,(a3)
	move.l d1,68(a0)
	move.w 4(a4),4(a3)
	move.l 6(a4),64(a0)

	swap d1
	move.w #$0003,72(a0)
	tst.w d1
	bne.s o49cae
	move.w #$0002,72(a0)
o49cae:
	addq.w #2,50(a0)
	bra.s o49d02
testpatjmp:
	cmpi.b #$e7,(a1)
	bne.s testnewsustain
	move.b 1(a1),d0
	andi.w #$00ff,d0
	lsl.w #6,d0
	move.l FRQpoint(pc),a1
	adda.w d0,a1
	move.l a1,18(a0)
	move.w d7,50(a0)
	bra.L testeffects
testnewsustain:
	cmpi.b #$e8,(a1)	;E8 = set sustain time
	bne.s o49cea
	move.b 1(a1),26(a0)
	addq.w #2,50(a0)
	bra.L testsustain
o49cea:
	cmpi.b #$e3,(a1)
	bne.s o49d02
	addq.w #3,50(a0)
	move.b 1(a1),27(a0)
	move.b 2(a1),28(a0)
o49d02:
	move.l 18(a0),a1
	adda.w 50(a0),a1
	move.b (a1),43(a0)
	addq.w #1,50(a0)
VOLUfx:
	tst.b 25(a0)
	beq.s o49d1e
	subq.b #1,25(a0)
	bra.s o49d70
o49d1e:
	subq.b #1,23(a0)
	bne.s o49d70
	move.b 24(a0),23(a0)
o49d2a:
	move.l 10(a0),a1
	adda.w 16(a0),a1
	move.b (a1),d0
	cmpi.b #$e8,d0
	bne.s o49d4a
	addq.w #2,16(a0)
	move.b 1(a1),25(a0)
	bra.s VOLUfx
o49d4a:
	cmpi.b #$e1,d0
	beq.s o49d70
	cmpi.b #$e0,d0
	bne.s o49d68
	move.b 1(a1),d0
	andi.l #$003f,d0
	subq.b #5,d0
	move.w d0,16(a0)
	bra.s o49d2a
o49d68:
	move.b (a1),45(a0)
	addq.w #1,16(a0)
o49d70:
	move.b 43(a0),d0
	bmi.s o49d7e
	add.b 8(a0),d0
	add.b 44(a0),d0
o49d7e:
	andi.w #$007f,d0
	lea PERIODS(pc),a1
	add.w d0,d0
	move.w d0,d1
	adda.w d0,a1
	move.w (a1),d0
	move.b 46(a0),d7
	tst.b 30(a0)
	beq.s o49d9e
	subq.b #1,30(a0)

	bra.s o49df4
o49d9e:
	move.b d1,d5
	move.b 28(a0),d4
	add.b d4,d4
	move.b 29(a0),d1
	tst.b d7
	bpl.s o49db4
	btst #0,d7
	bne.s o49dda
o49db4:
	btst #5,d7
	bne.s o49dc8
	sub.b 27(a0),d1
	bcc.s o49dd6
	bset #5,d7
	moveq #0,d1
	bra.s o49dd6
o49dc8:
	add.b 27(a0),d1
	cmp.b d4,d1
	bcs.s o49dd6
	bclr #5,d7
	move.b d4,d1
o49dd6:
	move.b d1,29(a0)
o49dda:
	lsr.b #1,d4
	sub.b d4,d1
	bcc.s o49de4
	subi.w #$0100,d1
o49de4:
	addi.b #$a0,d5
	bcs.s o49df2
o49dea:
	add.w d1,d1
	addi.b #$18,d5
	bcc.s o49dea
o49df2:
	add.w d1,d0
o49df4:
	eori.b #$01,d7
	move.b d7,46(a0)

; DO THE PORTAMENTO THING
	moveq #0,d1
	move.b 47(a0),d1	;get portavalue
	beq.s a56d0		;0=no portamento
	cmpi.b #$1f,d1
	bls.s portaup
portadown: 
	andi.w #$1f,d1
	neg.w d1
portaup:
	sub.w d1,56(a0)
a56d0:
	add.w 56(a0),d0
o49e3e:
	cmpi.w #$0070,d0
	bhi.s nn1
	move.w #$0071,d0
nn1:
	cmpi.w #$06b0,d0
	bls.s nn2
	move.w #$06b0,d0
nn2:
	moveq #0,d1
	move.b 45(a0),d1
	rts



pervol: dcb.b 16,0	;Periods & Volumes temp. store
respcnt: dc.w 0		;Replay speed counter 
repspd:  dc.w 0		;Replay speed counter temp
onoff:   dc.w 0		;Music on/off flag.
firseq:	 dc.w 0		;First sequence
lasseq:	 dc.w 0		;Last sequence
audtemp: dc.w 0
spdtemp: dc.w 0

V1data:  dcb.b 64,0	;Voice 1 data area
offset1: dcb.b 02,0	;Is added to start of sound
ssize1:  dcb.b 02,0	;Length of sound
start1:  dcb.b 06,0	;Start of sound

V2data:  dcb.b 64,0	;Voice 2 data area
offset2: dcb.b 02,0
ssize2:  dcb.b 02,0
start2:  dcb.b 06,0

V3data:  dcb.b 64,0	;Voice 3 data area
offset3: dcb.b 02,0
ssize3:  dcb.b 02,0
start3:  dcb.b 06,0

V4data:  dcb.b 64,0	;Voice 4 data area
offset4: dcb.b 02,0
ssize4:  dcb.b 02,0
start4:  dcb.b 06,0

o4a0c8: dc.l $00000000,$00100003,$00200006,$00300009
SEQpoint: dc.l 0
PATpoint: dc.l 0
FRQpoint: dc.l 0
VOLpoint: dc.l 0


even
SILENT: dc.w $0100,$0000,$0000,$00e1

PERIODS:dc.w $06b0,$0650,$05f4,$05a0,$054c,$0500,$04b8,$0474
	dc.w $0434,$03f8,$03c0,$038a,$0358,$0328,$02fa,$02d0
	dc.w $02a6,$0280,$025c,$023a,$021a,$01fc,$01e0,$01c5
	dc.w $01ac,$0194,$017d,$0168,$0153,$0140,$012e,$011d
	dc.w $010d,$00fe,$00f0,$00e2,$00d6,$00ca,$00be,$00b4
	dc.w $00aa,$00a0,$0097,$008f,$0087,$007f,$0078,$0071
	dc.w $0071,$0071,$0071,$0071,$0071,$0071,$0071,$0071
	dc.w $0071,$0071,$0071,$0071,$0d60,$0ca0,$0be8,$0b40
	dc.w $0a98,$0a00,$0970,$08e8,$0868,$07f0,$0780,$0714
	dc.w $1ac0,$1940,$17d0,$1680,$1530,$1400,$12e0,$11d0
	dc.w $10d0,$0fe0,$0f00,$0e28

SOUNDINFO:
;Offset.l , Sound-length.w , Start-offset.w , Repeat-length.w 

;Reserved for samples
	dc.w $0000,$0000 ,$0000 ,$0000 ,$0001 
	dc.w $0000,$0000 ,$0000 ,$0000 ,$0001 
	dc.w $0000,$0000 ,$0000 ,$0000 ,$0001 
	dc.w $0000,$0000 ,$0000 ,$0000 ,$0001 
	dc.w $0000,$0000 ,$0000 ,$0000 ,$0001 
	dc.w $0000,$0000 ,$0000 ,$0000 ,$0001 
	dc.w $0000,$0000 ,$0000 ,$0000 ,$0001 
	dc.w $0000,$0000 ,$0000 ,$0000 ,$0001 
	dc.w $0000,$0000 ,$0000 ,$0000 ,$0001 
	dc.w $0000,$0000 ,$0000 ,$0000 ,$0001 
;Reserved for synth sounds
	dc.w $0000,$0000 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0020 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0040 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0060 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0080 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$00a0 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$00c0 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$00e0 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0100 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0120 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0140 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0160 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0180 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$01a0 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$01c0 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$01e0 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0200 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0220 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0240 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0260 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0280 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$02a0 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$02c0 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$02e0 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0300 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0320 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0340 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0360 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0380 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$03a0 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$03c0 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$03e0 ,$0010 ,$0000 ,$0010 
	dc.w $0000,$0400 ,$0008 ,$0000 ,$0008 
	dc.w $0000,$0410 ,$0008 ,$0000 ,$0008 
	dc.w $0000,$0420 ,$0008 ,$0000 ,$0008 
	dc.w $0000,$0430 ,$0008 ,$0000 ,$0008 
	dc.w $0000,$0440 ,$0008 ,$0000 ,$0008
	dc.w $0000,$0450 ,$0008 ,$0000 ,$0008
	dc.w $0000,$0460 ,$0008 ,$0000 ,$0008
	dc.w $0000,$0470 ,$0008 ,$0000 ,$0008
	dc.w $0000,$0480 ,$0010 ,$0000 ,$0010
	dc.w $0000,$04a0 ,$0008 ,$0000 ,$0008
	dc.w $0000,$04b0 ,$0010 ,$0000 ,$0010
	dc.w $0000,$04d0 ,$0010 ,$0000 ,$0010
	dc.w $0000,$04f0 ,$0008 ,$0000 ,$0008
	dc.w $0000,$0500 ,$0008 ,$0000 ,$0008
	dc.w $0000,$0510 ,$0018 ,$0000 ,$0018
 

WAVEFORMS:
	dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w $3f37,$2f27,$1f17,$0f07,$ff07,$0f17,$1f27,$2f37
	dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w $c037,$2f27,$1f17,$0f07,$ff07,$0f17,$1f27,$2f37
	dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w $c0b8,$2f27,$1f17,$0f07,$ff07,$0f17,$1f27,$2f37
	dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w $c0b8,$b027,$1f17,$0f07,$ff07,$0f17,$1f27,$2f37
	dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w $c0b8,$b0a8,$1f17,$0f07,$ff07,$0f17,$1f27,$2f37
	dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w $c0b8,$b0a8,$a017,$0f07,$ff07,$0f17,$1f27,$2f37
	dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w $c0b8,$b0a8,$a098,$0f07,$ff07,$0f17,$1f27,$2f37
	dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w $c0b8,$b0a8,$a098,$9007,$ff07,$0f17,$1f27,$2f37
	dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w $c0b8,$b0a8,$a098,$9088,$ff07,$0f17,$1f27,$2f37
	dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w $c0b8,$b0a8,$a098,$9088,$8007,$0f17,$1f27,$2f37
	dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w $c0b8,$b0a8,$a098,$9088,$8088,$0f17,$1f27,$2f37
	dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w $c0b8,$b0a8,$a098,$9088,$8088,$9017,$1f27,$2f37
	dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w $c0b8,$b0a8,$a098,$9088,$8088,$9098,$1f27,$2f37
	dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w $c0b8,$b0a8,$a098,$9088,$8088,$9098,$a027,$2f37
	dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w $c0b8,$b0a8,$a098,$9088,$8088,$9098,$a0a8,$2f37
	dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w $c0b8,$b0a8,$a098,$9088,$8088,$9098,$a0a8,$b037
	dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w $7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w $817f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w $8181,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w $8181,$817f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w $8181,$8181,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w $8181,$8181,$817f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w $8181,$8181,$8181,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w $8181,$8181,$8181,$817f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w $8181,$8181,$8181,$8181,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w $8181,$8181,$8181,$8181,$817f,$7f7f,$7f7f,$7f7f
	dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w $8181,$8181,$8181,$8181,$8181,$7f7f,$7f7f,$7f7f
	dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w $8181,$8181,$8181,$8181,$8181,$817f,$7f7f,$7f7f
	dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w $8181,$8181,$8181,$8181,$8181,$8181,$7f7f,$7f7f
	dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w $8181,$8181,$8181,$8181,$8181,$8181,$817f,$7f7f
	dc.w $8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080
	dc.w $8080,$8080,$8080,$8080,$8080,$8080,$8080,$7f7f
	dc.w $8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080
	dc.w $8080,$8080,$8080,$8080,$8080,$8080,$8080,$807f
	dc.w $8080,$8080,$8080,$8080,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w $8080,$8080,$8080,$807f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w $8080,$8080,$8080,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w $8080,$8080,$807f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w $8080,$8080,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w $8080,$807f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w $8080,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w $8080,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w $8080,$9098,$a0a8,$b0b8,$c0c8,$d0d8,$e0e8,$f0f8
	dc.w $0008,$1018,$2028,$3038,$4048,$5058,$6068,$707f
	dc.w $8080,$a0b0,$c0d0,$e0f0,$0010,$2030,$4050,$6070
	dc.w $4545,$797d,$7a77,$7066,$6158,$534d,$2c20,$1812
	dc.w $04db,$d3cd,$c6bc,$b5ae,$a8a3,$9d99,$938e,$8b8a
	dc.w $4545,$797d,$7a77,$7066,$5b4b,$4337,$2c20,$1812
	dc.w $04f8,$e8db,$cfc6,$beb0,$a8a4,$9e9a,$9594,$8d83
	dc.w $0000,$4060,$7f60,$4020,$00e0,$c0a0,$80a0,$c0e0
	dc.w $0000,$4060,$7f60,$4020,$00e0,$c0a0,$80a0,$c0e0
	dc.w $8080,$9098,$a0a8,$b0b8,$c0c8,$d0d8,$e0e8,$f0f8
	dc.w $0008,$1018,$2028,$3038,$4048,$5058,$6068,$707f
	dc.w $8080,$a0b0,$c0d0,$e0f0,$0010,$2030,$4050,$6070


********* Data **********

TABLE:	DC.L	EFF0
	DC.L	EFF1
	DC.L	EFF2
	DC.L	EFF3
	DC.L	EFF4
	DC.L	EFF5
	DC.L	EFF6
	DC.L	EFF7
	DC.L	EFF8
	DC.L	EFF9

COLORS1:	
	DC.W	$0000,$0101,$0202,$0303,$0404,$0505,$0606,$0707
	DC.W	$0808,$0909,$0A0A,$0B0b,$0C0c,$0D0d,$0E0e,$0F0f
	dcb.W	$10,$0F0f
	DC.W	$0F0f,$0e0e,$0d0d,$0C0c,$0B0b,$0A0a,$0909,$0808
	DC.W	$0707,$0606,$0505,$0404,$0303,$0202,$0101,$0000

sprite0:
	dc.l	$7AD77B00,$00008000,$7CCE7D00,$80008000
	dc.l	$7E7A7F00,$80000000,$80348100,$00008000
	dc.l	$821C8300,$80008000,$84458500,$80000000
	dc.l	$86A48700,$00008000,$88C68900,$80008000
	dc.l	$8A548B00,$80000000,$8C568D00,$00008000
	dc.l	$8E6E8F00,$80008000,$908B9100,$80000000
	dc.l	$92129300,$00008000,$94529500,$80008000
	dc.l	$965A9700,$80000000,$98729900,$00008000
	dc.l	$9A609B00,$80008000,$9C769D00,$80000000
	dc.l	$9E5F9F00,$00008000,$A06BA100,$80008000
	dc.l	$A29EA300,$80000000,$A4BFA500,$00008000
	dc.l	$A65EA700,$80008000,$A8A1A900,$80000000
	dc.l	$AAADAB00,$00008000,$AC65AD00,$80008000
	dc.l	$AE5EAF00,$80000000,$B034B100,$00008000
	dc.l	$B241B300,$80008000,$B483B500,$80000000
	dc.l	$B69BB700,$00008000,$B886B900,$80008000
	dc.l	$BAB2BB00,$80000000,$BC43BD00,$00008000
	dc.l	$BE1ABF00,$80008000,$C068C100,$80000000
	dc.l	$C2FAC300,$00008000,$C407C500,$80008000
	dc.l	$C68BC700,$80000000,$C840C900,$00008000
	dc.l	$CA6DCB00,$80008000,$CC45CD00,$80000000
	dc.l	$CE0ECF00,$00008000,$D0E7D100,$80008000
	dc.l	$D287D300,$80000000,$D410D500,$00008000
	dc.l	$D617D700,$80008000,$D85AD900,$80000000
	dc.l	$DA1EDB00,$00008000,$DCACDD00,$80008000
	dc.l	$DE6DDF00,$80000000,$E014E100,$00008000
	dc.l	$E277E300,$80008000,$E4C7E500,$80000000
	dc.l	$E6DEE700,$00008000,$E8B8E900,$80008000
	dc.l	$EAB9EB00,$80000000,$EC36ED00,$00008000
	dc.l	$EE71EF00,$80008000,$F07FF100,$80000000
	dc.l	$F2C4F300,$00008000,$F407F500,$80008000
	dc.l	$F6AAF700,$80000000,$F828F900,$00008000
	dc.l	$FA70FB00,$80008000,$FC4DFD00,$80000000
	dc.l	$FED7FF00,$00008000,$00C40106,$80008000
	dc.l	$028C0306,$80000000,$04CC0506,$00008000
	dc.l	$06E00706,$80008000,$08D50906,$80000000
	dc.l	$0A060B06,$00008000,$0C290D06,$80008000
	dc.l	$0E8B0F06,$80000000,$10AF1106,$00008000
	dc.l	$12ED1306,$80008000,$14561506,$80000000
	dc.l	$164F1706,$00008000,$188D1906,$80008000
	dc.l	$1A7C1B06,$80000000,$1CA11D06,$00008000
	dc.l	$1ED21F06,$80008000,$20D22106,$80000000
	dc.l	$00000000  ; Stars made with the TTST-STAR-ED !
sprite0_end:

brit:	dc.l 	350
INTRPT0: DC.L	$0
SOURCEA: DC.L	$0
DEST:	DC.L	$0
COUNT:	DC.L	$0
PAUSA:	DC.B 	$0
half:	dc.b	$0
OFFSET:	DC.W	$0
SH:	DC.B	$0
PASSO:	DC.B	$4
SHIFT:	DC.W	$49F0
ST:	DC.B	$0
STEP:	DC.B	$0
CHCON:	DC.L	$0
bitcontrol: dc.w $0
comparator: dc.w $0
speed1:	dc.w 	$0
changed:dc.w 	$0
sinusloc: dc.l 	sinusmat3
save:	dc.b 	0,0
sspeed:	dc.b 	10,0
mask:	dc.w 	$c000
gn:	dc.b 	'graphics.library',0,0
	even
;------------------------ copperlist
copperl:
	dc.w $0120
sp1:	dc.w  $0000,$0122
sp2:	dc.w  $0000,$0124,$0000,$0126,$0000
	dc.w $0128,$0000,$012A,$0000,$012C,$0000,$012E,$0000
	dc.w $0130,$0000,$0132,$0000,$0134,$0000,$0136,$0000
	dc.w $0138,$0000,$013A,$0000,$013C,$0000,$013E,$0000
	dc.w $0092,$0038,$0094,$00d0,$008e,$2081,$0090,$28c1
	dc.w $00e0,$0004,$00e2,$c900,$00e4,$0004,$00e6,$d6e8
	dc.w $00e8,$0004,$00ea,$e4d0,$00ec,$0004,$00ee,$f2b8
	dc.w $00f0,$0005,$00f2,$00a0
	dc.w $0100,$5200
	dc.w $0102,$0000,$0104,$0000,$0108,$0000,$010a,$0000
	dc.w $0180,$0000,$0182,$0FFC,$0184,$0FFA,$0186,$0FF8
	dc.w $0188,$0FF6,$018A,$0FF4,$018C,$0FF2,$018E,$0FF0
	dc.w $0190,$0DC0,$0192,$0CA0,$0194,$0A80,$0196,$0960
	dc.w $0198,$0840,$019A,$0630,$019C,$0520,$019E,$0310
	dc.w $01A0,$0740,$01A2,$0740,$01A4,$0641,$01A6,$0641
	dc.w $01A8,$0541,$01AA,$0542,$01AC,$0532,$01AE,$0432
	dc.w $01B0,$0432,$01B2,$0332,$01B4,$0332,$01B6,$0322
	dc.w $01B8,$0222,$01BA,$0222,$01BC,$0111,$01BE,$0111
	dc.w $7901,$fffe,$0100,$0000

	DC.W $8037,$FFFE
LACE:
	dcb.W $060,$0180
	DC.W $0180,$0004

	dc.w $8201,$fffe,$0092,$0028,$0094,$00d0
	dc.w $00e0,$0004,$00e2,$09cc,$00e4,$0004,$00e6,$09cc+44
	dc.w $0100,$2200,$0102,$0010,$0108,$0000,$010a,$0000
	dc.w $0180,$0004,$0182,$0066,$0184,$00ee,$0186,$00aa
	dc.w $01a2,$0ddd,$01a4,$0444,$01a6,$0999

	dc.w $ffdf,$fffe
	dc.w $2401,$fffe,$0100,$0000
	DC.W $2437,$FFFE
LACE2:
	dcb.W $060,$0180
	DC.W $0180,$0000
	dc.w $ffff,$fffe
;------------------------ end copper
sinusmat3:
	dc.w	-69,-69,-69,-69,-69,-69,-69,-68
	dc.w	-68,-68,-68,-68,-67,-67,-67,-67
	dc.w	-66,-66,-66,-65,-65,-64,-64,-63
	dc.w	-63,-62,-62,-61,-61,-60,-60,-59
	dc.w	-58,-58,-57,-56,-56,-55,-54,-53
	dc.w	-53,-52,-51,-50,-49,-48,-48,-47
	dc.w	-46,-45,-44,-43,-42,-41,-40,-39
	dc.w	-38,-37,-36,-35,-34,-33,-32,-31
	dc.w	-30,-29,-27,-26,-25,-24,-23,-22
	dc.w	-21,-19,-18,-17,-16,-15,-14,-12
	dc.w	-11,-10,-9,-8,-6,-5,-4,-3
	dc.w	-1,0,0,1,2,4,5,6
	dc.w	7,9,10,11,12,13,15,16
	dc.w	17,18,19,20,22,23,24,25
	dc.w	26,27,28,30,31,32,33,34
	dc.w	35,36,37,38,39,40,41,42
	dc.w	43,44,45,46,47,48,49,49
	dc.w	50,51,52,53,54,54,55,56
	dc.w	57,57,58,59,59,60,61,61
	dc.w	62,62,63,63,64,64,65,65
	dc.w	66,66,67,67,67,68,68,68
	dc.w	68,69,69,69,69,69,70,70
	dc.w	70,70,70,70,70,70,70,70
	dc.w	70,70,70,69,69,69,69,69
	dc.w	68,68,68,68,67,67,67,66
	dc.w	66,65,65,64,64,63,63,62
	dc.w	62,61,61,60,59,59,58,57
	dc.w	57,56,55,54,54,53,52,51
	dc.w	50,49,49,48,47,46,45,44
	dc.w	43,42,41,40,39,38,37,36
	dc.w	35,34,33,32,31,30,28,27
	dc.w	26,25,24,23,22,20,19,18
	dc.w	17,16,15,13,12,11,10,9
	dc.w	7,6,5,4,2,1,0,0
	dc.w	-1,-3,-4,-5,-6,-8,-9,-10
	dc.w	-11,-12,-14,-15,-16,-17,-18,-19
	dc.w	-21,-22,-23,-24,-25,-26,-27,-29
	dc.w	-30,-31,-32,-33,-34,-35,-36,-37
	dc.w	-38,-39,-40,-41,-42,-43,-44,-45
	dc.w	-46,-47,-48,-48,-49,-50,-51,-52
	dc.w	-53,-53,-54,-55,-56,-56,-57,-58
	dc.w	-58,-59,-60,-60,-61,-61,-62,-62
	dc.w	-63,-63,-64,-64,-65,-65,-66,-66
	dc.w	-66,-67,-67,-67,-67,-68,-68,-68
	dc.w	-68,-68,-69,-69,-69,-69,-69,-69
	dcb.w	   20,$aaaa

; 0 = STOP	1 = NOTHING	2 = VEL 1
; 3 = VEL 2	4 = VEL 4	5 = VEL 8
; 6 = VEL 16	7 = STOP SINUS	8 = SINUS 8
; 9 = SINUS 10

TESTO:
	DC.B "    SAVAGE PROUDLY PRESENTS....    LIVINGSTONE II PART 1 --- "
	DC.B "WARNING ",7,"BECAUSE WITHOUT ONE MEG YOU WON'T BE ABLE TO PLAY "
	DC.B "THIS VERSION OF THE GAME - SORRY! ",8,"   GAME WAS CRACKED BY "
	DC.B "MAD AND PACKED INTO ONE FILE BY FILIPPETTO OF SAVAGE...      "
	DC.B "NOW THE SAME OLD SHIT - GREETINGS FROM SAVAGE TO:            "
	dc.b "ABANDON - AEON - ACL AUSTRIA - AHEAD - ALIVE - ANARCHY UK - "
	DC.B "ANIMATE - "
	dc.b "AOFCF - APACE - APEX - ALPHA FLIGHT - ATOMIX - AVENGER - "
	dc.b "BEASTY BOYS - BILLY AND JOHN - BIONIC FORCE - BLACK MONKS - "
	dc.b "BYTERAPERS INC - CAVE - CELTIC - CLONES - COAST - COSA NOSTRA - "
	dc.b "COPY CREW - COMPLEX - CRYPTOBURNERS - CYCRON - D MOB - D TECH - "
	DC.B "DDC - DESASTER AREA - "
	dc.b "DEFCON ONE - DIGITECH - DOC - DUAL CREW - ENERGY AUSTRIA - "
	dc.b "ESA - ESCAPE GERMANY - EXCEL UK - EXODUS - FINE - "
	dc.b "FREEDOM FORCE AND AMIGA INDUSTRIES - IBB - ICS - IPEC ELITE - "
	dc.b "JUNGLE COMMAND - KEFRENS - MASTERCREW AND ELIMINATION - "
	dc.b "MECHANIX - MYTHOS - NUKEBUSTERS - PHAZE 101 - QUICKSILVER - "
	dc.b "REBELS - SAGA CONNECTION - SARGON - SAVATAGE - SETROX - SCANNEX - "
	dc.b "SIGN - SHINING EIGHT - SPECTRE - SUCCESS - SUPREME - SYSTEM 5 - "
	dc.b "TARKUS TEAM - THE BAND - THE LOST BOYS - THE FORCE - "
	dc.b "THE WIZZARDS - TOP SWAP - TSK AND ALCATRAZ - TTST - UNIQUE - "
	dc.b "VISION - VISION FACTORY - VISUAL ARTS - WARFALCONS           "
	dc.b "    OF COURSE WE MAY HAVE FORGOTTEN SOMEONE. SORRY!     "
	DC.B "       CONTACT SAVAGE: P.O.BOX 46 - 8607 "
	DC.B "KAPFENBERG - AUSTRIA     OR     FILIPPO RIZZI - VIA VESCOVADO 39 "
	DC.B "- 35100 PADOVA - ITALY                  BYE                   "
	dc.b $ff,$ff,$ff,$ff

;>extern "TUNE1",module
;>extern "charset10",charset
;>extern "svglogo",logo

module  incbin	"TUNE1"		;= $50e88
logo    incbin	"svglogo"	;= $4c900
charset incbin	"charset10"	;= $4c000

	section	bss,bss_c
screen2 ds.b	$10000		;= $30000
screen1	ds.b	$10000		;= $40000
